package net.minecraft.src;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import net.minecraft.client.Minecraft;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

public class GuiIngame extends Gui {
	private static RenderItem itemRenderer = new RenderItem();
	private List chatMessageList = new ArrayList();
	private Random rand = new Random();
	private Minecraft mc;
	public String field_933_a = null;
	private int updateCounter = 0;
	private String recordPlaying = "";
	private int recordPlayingUpFor = 0;
	private boolean recordIsPlaying = false;
	public float damageGuiPartialTime;
	float prevVignetteBrightness = 1.0F;

	public GuiIngame(Minecraft minecraft1) {
		this.mc = minecraft1;
	}

	public void renderGameOverlay(float f1, boolean z2, int i3, int i4) {
		ScaledResolution scaledResolution5 = new ScaledResolution(this.mc.gameSettings, this.mc.displayWidth, this.mc.displayHeight);
		int i6 = scaledResolution5.getScaledWidth();
		int i7 = scaledResolution5.getScaledHeight();
		FontRenderer fontRenderer8 = this.mc.fontRenderer;
		this.mc.entityRenderer.func_905_b();
		GL11.glEnable(GL11.GL_BLEND);
		if(Minecraft.isFancyGraphicsEnabled()) {
			this.renderVignette(this.mc.thePlayer.getEntityBrightness(f1), i6, i7);
		}

		ItemStack itemStack9 = this.mc.thePlayer.inventory.armorItemInSlot(3);
		if(!this.mc.gameSettings.thirdPersonView && itemStack9 != null && itemStack9.itemID == Block.pumpkin.blockID) {
			this.renderPumpkinBlur(i6, i7);
		}

		float f10;
		if(!this.mc.thePlayer.func_35160_a(Potion.field_35684_k)) {
			f10 = this.mc.thePlayer.prevTimeInPortal + (this.mc.thePlayer.timeInPortal - this.mc.thePlayer.prevTimeInPortal) * f1;
			if(f10 > 0.0F) {
				this.renderPortalOverlay(f10, i6, i7);
			}
		}

		boolean z11;
		int i12;
		int i13;
		int i14;
		int i15;
		int i16;
		int i17;
		int i18;
		int i20;
		int i24;
		int i28;
		byte b29;
		int i30;
		int i49;
		byte b50;
		if(!this.mc.playerController.func_35643_e()) {
			GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("/gui/gui.png"));
			InventoryPlayer inventoryPlayer19 = this.mc.thePlayer.inventory;
			this.zLevel = -90.0F;
			this.drawTexturedModalRect(i6 / 2 - 91, i7 - 22, 0, 0, 182, 22);
			this.drawTexturedModalRect(i6 / 2 - 91 - 1 + inventoryPlayer19.currentItem * 20, i7 - 22 - 1, 0, 22, 24, 22);
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("/gui/icons.png"));
			GL11.glEnable(GL11.GL_BLEND);
			GL11.glBlendFunc(GL11.GL_ONE_MINUS_DST_COLOR, GL11.GL_ONE_MINUS_SRC_COLOR);
			this.drawTexturedModalRect(i6 / 2 - 7, i7 / 2 - 7, 0, 0, 16, 16);
			GL11.glDisable(GL11.GL_BLEND);
			z11 = this.mc.thePlayer.heartsLife / 3 % 2 == 1;
			if(this.mc.thePlayer.heartsLife < 10) {
				z11 = false;
			}

			i12 = this.mc.thePlayer.health;
			i20 = this.mc.thePlayer.prevHealth;
			this.rand.setSeed((long)(this.updateCounter * 312871));
			boolean z21 = false;
			FoodStats foodStats22 = this.mc.thePlayer.func_35191_at();
			i13 = foodStats22.func_35765_a();
			i14 = foodStats22.func_35769_b();
			int i23;
			if(this.mc.playerController.shouldDrawHUD()) {
				i15 = i6 / 2 - 91;
				i23 = i6 / 2 + 91;
				i16 = this.mc.thePlayer.func_35193_as();
				if(i16 > 0) {
					short s25 = 182;
					i17 = this.mc.thePlayer.field_35211_aX * (s25 + 1) / this.mc.thePlayer.func_35193_as();
					i24 = i7 - 32 + 3;
					this.drawTexturedModalRect(i15, i24, 0, 64, s25, 5);
					if(i17 > 0) {
						this.drawTexturedModalRect(i15, i24, 0, 69, i17, 5);
					}
				}

				i18 = i7 - 39;
				i17 = i18 - 10;
				i24 = this.mc.thePlayer.getPlayerArmorValue();
				int i44 = -1;
				if(this.mc.thePlayer.func_35160_a(Potion.field_35681_l)) {
					i44 = this.updateCounter % 25;
				}

				int i26;
				int i27;
				for(i26 = 0; i26 < 10; ++i26) {
					if(i24 > 0) {
						i27 = i15 + i26 * 8;
						if(i26 * 2 + 1 < i24) {
							this.drawTexturedModalRect(i27, i17, 34, 9, 9, 9);
						}

						if(i26 * 2 + 1 == i24) {
							this.drawTexturedModalRect(i27, i17, 25, 9, 9, 9);
						}

						if(i26 * 2 + 1 > i24) {
							this.drawTexturedModalRect(i27, i17, 16, 9, 9, 9);
						}
					}

					i27 = 16;
					if(this.mc.thePlayer.func_35160_a(Potion.field_35689_u)) {
						i27 += 36;
					}

					b29 = 0;
					if(z11) {
						b29 = 1;
					}

					i30 = i15 + i26 * 8;
					i28 = i18;
					if(i12 <= 4) {
						i28 = i18 + this.rand.nextInt(2);
					}

					if(i26 == i44) {
						i28 -= 2;
					}

					this.drawTexturedModalRect(i30, i28, 16 + b29 * 9, 0, 9, 9);
					if(z11) {
						if(i26 * 2 + 1 < i20) {
							this.drawTexturedModalRect(i30, i28, i27 + 54, 0, 9, 9);
						}

						if(i26 * 2 + 1 == i20) {
							this.drawTexturedModalRect(i30, i28, i27 + 63, 0, 9, 9);
						}
					}

					if(i26 * 2 + 1 < i12) {
						this.drawTexturedModalRect(i30, i28, i27 + 36, 0, 9, 9);
					}

					if(i26 * 2 + 1 == i12) {
						this.drawTexturedModalRect(i30, i28, i27 + 45, 0, 9, 9);
					}
				}

				for(i26 = 0; i26 < 10; ++i26) {
					i27 = i18;
					i49 = 16;
					b50 = 0;
					if(this.mc.thePlayer.func_35160_a(Potion.field_35691_s)) {
						i49 += 36;
						b50 = 13;
					}

					if(this.mc.thePlayer.func_35191_at().func_35760_d() <= 0.0F && this.updateCounter % (i13 * 3 + 1) == 0) {
						i27 = i18 + (this.rand.nextInt(3) - 1);
					}

					if(z21) {
						b50 = 1;
					}

					i28 = i23 - i26 * 8 - 9;
					this.drawTexturedModalRect(i28, i27, 16 + b50 * 9, 27, 9, 9);
					if(z21) {
						if(i26 * 2 + 1 < i14) {
							this.drawTexturedModalRect(i28, i27, i49 + 54, 27, 9, 9);
						}

						if(i26 * 2 + 1 == i14) {
							this.drawTexturedModalRect(i28, i27, i49 + 63, 27, 9, 9);
						}
					}

					if(i26 * 2 + 1 < i13) {
						this.drawTexturedModalRect(i28, i27, i49 + 36, 27, 9, 9);
					}

					if(i26 * 2 + 1 == i13) {
						this.drawTexturedModalRect(i28, i27, i49 + 45, 27, 9, 9);
					}
				}

				if(this.mc.thePlayer.isInsideOfMaterial(Material.water)) {
					i26 = (int)Math.ceil((double)(this.mc.thePlayer.air - 2) * 10.0D / 300.0D);
					i27 = (int)Math.ceil((double)this.mc.thePlayer.air * 10.0D / 300.0D) - i26;

					for(i49 = 0; i49 < i26 + i27; ++i49) {
						if(i49 < i26) {
							this.drawTexturedModalRect(i23 - i49 * 8 - 9, i17, 16, 18, 9, 9);
						} else {
							this.drawTexturedModalRect(i23 - i49 * 8 - 9, i17, 25, 18, 9, 9);
						}
					}
				}
			}

			GL11.glDisable(GL11.GL_BLEND);
			GL11.glEnable(GL12.GL_RESCALE_NORMAL);
			GL11.glPushMatrix();
			GL11.glRotatef(120.0F, 1.0F, 0.0F, 0.0F);
			RenderHelper.enableStandardItemLighting();
			GL11.glPopMatrix();

			for(i15 = 0; i15 < 9; ++i15) {
				i23 = i6 / 2 - 90 + i15 * 20 + 2;
				i16 = i7 - 16 - 3;
				this.renderInventorySlot(i15, i23, i16, f1);
			}

			RenderHelper.disableStandardItemLighting();
			GL11.glDisable(GL12.GL_RESCALE_NORMAL);
		}

		if(this.mc.thePlayer.func_22060_M() > 0) {
			GL11.glDisable(GL11.GL_DEPTH_TEST);
			GL11.glDisable(GL11.GL_ALPHA_TEST);
			int i33 = this.mc.thePlayer.func_22060_M();
			float f35 = (float)i33 / 100.0F;
			if(f35 > 1.0F) {
				f35 = 1.0F - (float)(i33 - 100) / 10.0F;
			}

			i12 = (int)(220.0F * f35) << 24 | 1052704;
			this.drawRect(0, 0, i6, i7, i12);
			GL11.glEnable(GL11.GL_ALPHA_TEST);
			GL11.glEnable(GL11.GL_DEPTH_TEST);
		}

		if(this.mc.playerController.func_35642_f() && this.mc.thePlayer.field_35210_aY > 0) {
			;
		}

		String string34;
		if(this.mc.gameSettings.showDebugInfo) {
			GL11.glPushMatrix();
			if(Minecraft.hasPaidCheckTime > 0L) {
				GL11.glTranslatef(0.0F, 32.0F, 0.0F);
			}

			fontRenderer8.drawStringWithShadow("Minecraft ", 2, 2, 10375468);
			fontRenderer8.drawStringWithShadow("Beta 1.8.1", 2 + fontRenderer8.getStringWidth("Minecraft "), 2, 43008);
			fontRenderer8.drawStringWithShadow(" (" + this.mc.debug + ")", 2 + fontRenderer8.getStringWidth("Minecraft Beta 1.8.1"), 2, 16579668);
			fontRenderer8.drawStringWithShadow(this.mc.debugInfoRenders(), 2, 12, 0xFFFFFF);
			fontRenderer8.drawStringWithShadow(this.mc.func_6262_n(), 2, 22, 0xFFFFFF);
			fontRenderer8.drawStringWithShadow(this.mc.debugInfoEntities(), 2, 32, 0xFFFFFF);
			fontRenderer8.drawStringWithShadow(this.mc.func_21002_o(), 2, 152, 0xFFFFFF);
			long j36 = Runtime.getRuntime().maxMemory();
			long j38 = Runtime.getRuntime().totalMemory();
			long j42 = Runtime.getRuntime().freeMemory();
			long j47 = j38 - j42;
			string34 = "Used memory: " + j47 * 100L / j36 + "% (" + j47 / 1024L / 1024L + "MB) of " + j36 / 1024L / 1024L + "MB";
			this.drawString(fontRenderer8, string34, i6 - fontRenderer8.getStringWidth(string34) - 2, 2, 14737632);
			string34 = "Allocated memory: " + j38 * 100L / j36 + "% (" + j38 / 1024L / 1024L + "MB)";
			this.drawString(fontRenderer8, string34, i6 - fontRenderer8.getStringWidth(string34) - 2, 12, 14737632);
			i28 = MathHelper.floor_double(this.mc.thePlayer.posX);
			i49 = MathHelper.floor_double(this.mc.thePlayer.posY);
			i30 = MathHelper.floor_double(this.mc.thePlayer.posZ);
			fontRenderer8.drawStringWithShadow("X", 2, 102, 16536660);
			fontRenderer8.drawStringWithShadow("Y", 2 + fontRenderer8.getStringWidth("X"), 102, 5569620);
			fontRenderer8.drawStringWithShadow("Z", 2 + fontRenderer8.getStringWidth("XY"), 102, 5569788);
			fontRenderer8.drawStringWithShadow(String.format(": %.4f ", new Object[]{this.mc.thePlayer.posX}), 2 + fontRenderer8.getStringWidth("XYZ"), 102, 16536660);
			fontRenderer8.drawStringWithShadow(String.format(" %.4f ", new Object[]{this.mc.thePlayer.posY}), 2 + fontRenderer8.getStringWidth("XYZ" + String.format(": %.4f ", new Object[]{this.mc.thePlayer.posX})), 102, 5569620);
			fontRenderer8.drawStringWithShadow(String.format(" %.4f", new Object[]{this.mc.thePlayer.posZ}), 2 + fontRenderer8.getStringWidth("XYZ" + String.format(": %.4f ", new Object[]{this.mc.thePlayer.posX}) + String.format(" %.4f ", new Object[]{this.mc.thePlayer.posY})), 102, 5569788);
			fontRenderer8.drawStringWithShadow("SPAWN ", 2, 112, 43260);
			fontRenderer8.drawStringWithShadow("X", 2 + fontRenderer8.getStringWidth("SPAWN "), 112, 16536660);
			fontRenderer8.drawStringWithShadow("Y", 2 + fontRenderer8.getStringWidth("SPAWN X"), 112, 5569620);
			fontRenderer8.drawStringWithShadow("Z", 2 + fontRenderer8.getStringWidth("SPAWN XY"), 112, 5569788);
			fontRenderer8.drawStringWithShadow(": " + this.mc.theWorld.worldInfo.spawnX, 2 + fontRenderer8.getStringWidth("SPAWN XYZ"), 112, 16536660);
			fontRenderer8.drawStringWithShadow(" " + this.mc.theWorld.worldInfo.spawnY, 2 + fontRenderer8.getStringWidth("SPAWN XYZ: " + this.mc.theWorld.worldInfo.spawnX), 112, 5569620);
			fontRenderer8.drawStringWithShadow(" " + this.mc.theWorld.worldInfo.spawnZ, 2 + fontRenderer8.getStringWidth("SPAWN XYZ: " + this.mc.theWorld.worldInfo.spawnX + " " + this.mc.theWorld.worldInfo.spawnY), 112, 5569788);
			int i31 = MathHelper.floor_double((double)(this.mc.thePlayer.rotationYaw * 4.0F / 360.0F) + 0.5D) & 3;
			this.drawString(fontRenderer8, "Direction: " + i31 + " (" + Direction.directions[i31] + ") / " + MathHelper.wrapAngleTo180_float(this.mc.thePlayer.rotationYaw), 2, 122, 0xFFFFFF);
			if(this.mc.theWorld != null && this.mc.theWorld.blockExists(i28, i49, i30)) {
				Chunk chunk32 = this.mc.theWorld.getChunkFromBlockCoords(i28, i30);
				fontRenderer8.drawStringWithShadow("Block Light: ", 2, 132, 43260);
				fontRenderer8.drawStringWithShadow("" + chunk32.getSavedLightValue(EnumSkyBlock.Block, i28 & 15, i49, i30 & 15), 2 + fontRenderer8.getStringWidth("Block Light: "), 132, 5569620);
				fontRenderer8.drawStringWithShadow(", Sky Light: ", 2 + fontRenderer8.getStringWidth("Block Light: " + chunk32.getSavedLightValue(EnumSkyBlock.Block, i28 & 15, i49, i30 & 15)), 132, 43260);
				fontRenderer8.drawStringWithShadow("" + chunk32.getSavedLightValue(EnumSkyBlock.Sky, i28 & 15, i49, i30 & 15), 2 + fontRenderer8.getStringWidth("Block Light: " + chunk32.getSavedLightValue(EnumSkyBlock.Block, i28 & 15, i49, i30 & 15) + " Sky Light: "), 132, 5569620);
				fontRenderer8.drawStringWithShadow(", Combined Light: ", 2 + fontRenderer8.getStringWidth("Block Light: " + chunk32.getSavedLightValue(EnumSkyBlock.Block, i28 & 15, i49, i30 & 15) + " Sky Light: " + chunk32.getSavedLightValue(EnumSkyBlock.Sky, i28 & 15, i49, i30 & 15)), 132, 43260);
				fontRenderer8.drawStringWithShadow("" + chunk32.getBlockLightValue(i28 & 15, i49, i30 & 15, 0), 2 + fontRenderer8.getStringWidth("Block Light: " + chunk32.getSavedLightValue(EnumSkyBlock.Block, i28 & 15, i49, i30 & 15) + " Sky Light: " + chunk32.getSavedLightValue(EnumSkyBlock.Sky, i28 & 15, i49, i30 & 15) + " Combined Light: "), 132, 5569620);
			}

			fontRenderer8.drawStringWithShadow("On Ground:", 2, 142, 43260);
			fontRenderer8.drawStringWithShadow(String.format(" %b", new Object[]{this.mc.thePlayer.onGround}), 2 + fontRenderer8.getStringWidth("On Ground:"), 142, 5569620);
			fontRenderer8.drawStringWithShadow(", ", 2 + fontRenderer8.getStringWidth("On Ground:" + String.format(" %b", new Object[]{this.mc.thePlayer.onGround})), 142, 0xFFFFFF);
			fontRenderer8.drawStringWithShadow("Highest Block:", 2 + fontRenderer8.getStringWidth("On Ground:" + String.format(" %b", new Object[]{this.mc.thePlayer.onGround}) + ", "), 142, 43260);
			fontRenderer8.drawStringWithShadow(String.format(" %d", new Object[]{this.mc.theWorld.getHeightValue(i28, i30)}), 2 + fontRenderer8.getStringWidth("On Ground:" + String.format(" %b", new Object[]{this.mc.thePlayer.onGround}) + ", Highest Block:"), 142, 5569620);
			this.drawString(fontRenderer8, "Seed: " + this.mc.theWorld.getRandomSeed(), 2, 162, 14737632);
			GL11.glPopMatrix();
		} else {
			fontRenderer8.drawStringWithShadow("Minecraft Beta 1.8.1", 2, 2, 0xFFFFFF);
		}

		if(this.recordPlayingUpFor > 0) {
			f10 = (float)this.recordPlayingUpFor - f1;
			i20 = (int)(f10 * 256.0F / 20.0F);
			if(i20 > 255) {
				i20 = 255;
			}

			if(i20 > 0) {
				GL11.glPushMatrix();
				GL11.glTranslatef((float)(i6 / 2), (float)(i7 - 48), 0.0F);
				GL11.glEnable(GL11.GL_BLEND);
				GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
				i12 = 0xFFFFFF;
				if(this.recordIsPlaying) {
					i12 = Color.HSBtoRGB(f10 / 50.0F, 0.7F, 0.6F) & 0xFFFFFF;
				}

				fontRenderer8.drawString(this.recordPlaying, -fontRenderer8.getStringWidth(this.recordPlaying) / 2, -4, i12 + (i20 << 24));
				GL11.glDisable(GL11.GL_BLEND);
				GL11.glPopMatrix();
			}
		}

		byte b39 = 10;
		z11 = false;
		if(this.mc.currentScreen instanceof GuiChat) {
			b39 = 20;
			z11 = true;
		}

		GL11.glEnable(GL11.GL_BLEND);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GL11.glDisable(GL11.GL_ALPHA_TEST);
		GL11.glPushMatrix();
		GL11.glTranslatef(0.0F, (float)(i7 - 48), 0.0F);

		int i37;
		for(i12 = 0; i12 < this.chatMessageList.size() && i12 < b39; ++i12) {
			if(((ChatLine)this.chatMessageList.get(i12)).updateCounter < 200 || z11) {
				double d40 = (double)((ChatLine)this.chatMessageList.get(i12)).updateCounter / 200.0D;
				d40 = 1.0D - d40;
				d40 *= 10.0D;
				if(d40 < 0.0D) {
					d40 = 0.0D;
				}

				if(d40 > 1.0D) {
					d40 = 1.0D;
				}

				d40 *= d40;
				i37 = (int)(255.0D * d40);
				if(z11) {
					i37 = 255;
				}

				if(i37 > 0) {
					byte b43 = 2;
					i14 = -i12 * 9;
					string34 = ((ChatLine)this.chatMessageList.get(i12)).message;
					this.drawRect(b43, i14 - 1, b43 + 320, i14 + 8, i37 / 2 << 24);
					GL11.glEnable(GL11.GL_BLEND);
					fontRenderer8.drawStringWithShadow(string34, b43, i14, 0xFFFFFF + (i37 << 24));
				}
			}
		}

		GL11.glPopMatrix();
		if(this.mc.thePlayer instanceof EntityClientPlayerMP && this.mc.gameSettings.field_35384_x.field_35965_e) {
			NetClientHandler netClientHandler45 = ((EntityClientPlayerMP)this.mc.thePlayer).sendQueue;
			List list41 = netClientHandler45.field_35786_c;
			i24 = netClientHandler45.field_35785_d;
			i37 = i24;

			for(i13 = 1; i37 > 20; i37 = (i24 + i13 - 1) / i13) {
				++i13;
			}

			i14 = 300 / i13;
			if(i14 > 150) {
				i14 = 150;
			}

			i15 = (i6 - i13 * i14) / 2;
			byte b46 = 10;
			this.drawRect(i15 - 1, b46 - 1, i15 + i14 * i13, b46 + 9 * i37, Integer.MIN_VALUE);

			for(i16 = 0; i16 < i24; ++i16) {
				i18 = i15 + i16 % i13 * i14;
				i17 = b46 + i16 / i13 * 9;
				this.drawRect(i18, i17, i18 + i14 - 1, i17 + 8, 553648127);
				GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
				GL11.glEnable(GL11.GL_ALPHA_TEST);
				if(i16 < list41.size()) {
					GuiSavingLevelString guiSavingLevelString48 = (GuiSavingLevelString)list41.get(i16);
					fontRenderer8.drawStringWithShadow(guiSavingLevelString48.field_35624_a, i18, i17, 0xFFFFFF);
					this.mc.renderEngine.bindTexture(this.mc.renderEngine.getTexture("/gui/icons.png"));
					boolean z52 = false;
					boolean z51 = false;
					b29 = 0;
					z51 = false;
					if(guiSavingLevelString48.field_35623_b < 0) {
						b50 = 5;
					} else if(guiSavingLevelString48.field_35623_b < 150) {
						b50 = 0;
					} else if(guiSavingLevelString48.field_35623_b < 300) {
						b50 = 1;
					} else if(guiSavingLevelString48.field_35623_b < 600) {
						b50 = 2;
					} else if(guiSavingLevelString48.field_35623_b < 1000) {
						b50 = 3;
					} else {
						b50 = 4;
					}

					this.zLevel += 100.0F;
					this.drawTexturedModalRect(i18 + i14 - 12, i17, 0 + b29 * 10, 176 + b50 * 8, 10, 8);
					this.zLevel -= 100.0F;
				}
			}
		}

		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		GL11.glDisable(GL11.GL_LIGHTING);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
	}

	private void renderPumpkinBlur(int i1, int i2) {
		GL11.glDisable(GL11.GL_DEPTH_TEST);
		GL11.glDepthMask(false);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		GL11.glDisable(GL11.GL_ALPHA_TEST);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("%blur%/misc/pumpkinblur.png"));
		Tessellator tessellator3 = Tessellator.instance;
		tessellator3.startDrawingQuads();
		tessellator3.addVertexWithUV(0.0D, (double)i2, -90.0D, 0.0D, 1.0D);
		tessellator3.addVertexWithUV((double)i1, (double)i2, -90.0D, 1.0D, 1.0D);
		tessellator3.addVertexWithUV((double)i1, 0.0D, -90.0D, 1.0D, 0.0D);
		tessellator3.addVertexWithUV(0.0D, 0.0D, -90.0D, 0.0D, 0.0D);
		tessellator3.draw();
		GL11.glDepthMask(true);
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
	}

	private void renderVignette(float f1, int i2, int i3) {
		f1 = 1.0F - f1;
		if(f1 < 0.0F) {
			f1 = 0.0F;
		}

		if(f1 > 1.0F) {
			f1 = 1.0F;
		}

		this.prevVignetteBrightness = (float)((double)this.prevVignetteBrightness + (double)(f1 - this.prevVignetteBrightness) * 0.01D);
		GL11.glDisable(GL11.GL_DEPTH_TEST);
		GL11.glDepthMask(false);
		GL11.glBlendFunc(GL11.GL_ZERO, GL11.GL_ONE_MINUS_SRC_COLOR);
		GL11.glColor4f(this.prevVignetteBrightness, this.prevVignetteBrightness, this.prevVignetteBrightness, 1.0F);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("%blur%/misc/vignette.png"));
		Tessellator tessellator4 = Tessellator.instance;
		tessellator4.startDrawingQuads();
		tessellator4.addVertexWithUV(0.0D, (double)i3, -90.0D, 0.0D, 1.0D);
		tessellator4.addVertexWithUV((double)i2, (double)i3, -90.0D, 1.0D, 1.0D);
		tessellator4.addVertexWithUV((double)i2, 0.0D, -90.0D, 1.0D, 0.0D);
		tessellator4.addVertexWithUV(0.0D, 0.0D, -90.0D, 0.0D, 0.0D);
		tessellator4.draw();
		GL11.glDepthMask(true);
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
	}

	private void renderPortalOverlay(float f1, int i2, int i3) {
		if(f1 < 1.0F) {
			f1 *= f1;
			f1 *= f1;
			f1 = f1 * 0.8F + 0.2F;
		}

		GL11.glDisable(GL11.GL_ALPHA_TEST);
		GL11.glDisable(GL11.GL_DEPTH_TEST);
		GL11.glDepthMask(false);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, f1);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.mc.renderEngine.getTexture("/terrain.png"));
		float f4 = (float)(Block.portal.blockIndexInTexture % 16) / 16.0F;
		float f5 = (float)(Block.portal.blockIndexInTexture / 16) / 16.0F;
		float f6 = (float)(Block.portal.blockIndexInTexture % 16 + 1) / 16.0F;
		float f7 = (float)(Block.portal.blockIndexInTexture / 16 + 1) / 16.0F;
		Tessellator tessellator8 = Tessellator.instance;
		tessellator8.startDrawingQuads();
		tessellator8.addVertexWithUV(0.0D, (double)i3, -90.0D, (double)f4, (double)f7);
		tessellator8.addVertexWithUV((double)i2, (double)i3, -90.0D, (double)f6, (double)f7);
		tessellator8.addVertexWithUV((double)i2, 0.0D, -90.0D, (double)f6, (double)f5);
		tessellator8.addVertexWithUV(0.0D, 0.0D, -90.0D, (double)f4, (double)f5);
		tessellator8.draw();
		GL11.glDepthMask(true);
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
	}

	private void renderInventorySlot(int i1, int i2, int i3, float f4) {
		ItemStack itemStack5 = this.mc.thePlayer.inventory.mainInventory[i1];
		if(itemStack5 != null) {
			float f6 = (float)itemStack5.animationsToGo - f4;
			if(f6 > 0.0F) {
				GL11.glPushMatrix();
				float f7 = 1.0F + f6 / 5.0F;
				GL11.glTranslatef((float)(i2 + 8), (float)(i3 + 12), 0.0F);
				GL11.glScalef(1.0F / f7, (f7 + 1.0F) / 2.0F, 1.0F);
				GL11.glTranslatef((float)(-(i2 + 8)), (float)(-(i3 + 12)), 0.0F);
			}

			itemRenderer.renderItemIntoGUI(this.mc.fontRenderer, this.mc.renderEngine, itemStack5, i2, i3);
			if(f6 > 0.0F) {
				GL11.glPopMatrix();
			}

			itemRenderer.renderItemOverlayIntoGUI(this.mc.fontRenderer, this.mc.renderEngine, itemStack5, i2, i3);
		}

	}

	public void updateTick() {
		if(this.recordPlayingUpFor > 0) {
			--this.recordPlayingUpFor;
		}

		++this.updateCounter;

		for(int i1 = 0; i1 < this.chatMessageList.size(); ++i1) {
			++((ChatLine)this.chatMessageList.get(i1)).updateCounter;
		}

	}

	public void clearChatMessages() {
		this.chatMessageList.clear();
	}

	public void addChatMessage(String string1) {
		while(this.mc.fontRenderer.getStringWidth(string1) > 320) {
			int i2;
			for(i2 = 1; i2 < string1.length() && this.mc.fontRenderer.getStringWidth(string1.substring(0, i2 + 1)) <= 320; ++i2) {
			}

			this.addChatMessage(string1.substring(0, i2));
			string1 = string1.substring(i2);
		}

		this.chatMessageList.add(0, new ChatLine(string1));

		while(this.chatMessageList.size() > 50) {
			this.chatMessageList.remove(this.chatMessageList.size() - 1);
		}

	}

	public void setRecordPlayingMessage(String string1) {
		this.recordPlaying = "Now playing: " + string1;
		this.recordPlayingUpFor = 60;
		this.recordIsPlaying = true;
	}

	public void addChatMessageTranslate(String string1) {
		StringTranslate stringTranslate2 = StringTranslate.getInstance();
		String string3 = stringTranslate2.translateKey(string1);
		this.addChatMessage(string3);
	}
}
